/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_config.c 697 2007-12-25 04:43:57Z honda $
 */

/*
 *		vZbTˑW[iSH12Apj
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 * ReLXgQƂ̂߂̕ϐ
 */
uint32_t excnest_count; /* Oi/CPUOj̃lXg񐔂̃JEg */

/*
 *  CPUbNtÔ߂̕ϐ
 */
volatile bool_t		lock_flag;		/* CPUbNtO̒lێϐ */
volatile uint32_t	saved_iipm;		/* ݗDx}XNۑϐ */

/*
 *  eݔԍIPȐǗe[u
 *  e̒`́CvZbT^ԖɈقȂ̂߁C
 *  vZbT^Ԗ̒`t@CŒ`
 */
const IPR_INFO ipr_info_tbl[TNUM_INH] = {
    IPR_INFO_TBL_DATA 
};

/*
 *  J[l̃xN^
 *  @@prc_initialize()set_vbr̂ɕKv
 */
extern const FP vectors;

/*
 *  vZbTˑ̏
 */
void
prc_initialize(void)
{
   /*
    *  J[lN͔^XNReLXgƂē삳邽1
    */ 
    excnest_count = 1;
    
    /*
     *  CPUbNtÔ߂̕ϐ̏
     */
    lock_flag = true;
    saved_iipm = IIPM_ENAALL;
    
    /*
     *  ݃Rg[̏
     *  vZbTɒ` 
     */
    init_irc();

    /*
     *  xN^[x[XWX^̏
     */
    set_vbr((void *)&vectors);
}

/*
 *  vZbTˑ̏I
 */
void
prc_terminate(void)
{
}

/*
 *  ݗvC̐ݒ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    assert(VALID_INTNO_CFGINT(intno));
    assert((-15 <= intpri) && (intpri <= TMAX_INTPRI));

    /* 
     *  U݂֎~
     */    
    (void)x_disable_int(intno);

    /*
     *  xgK/GbWgK̐ݒ
     */
    x_config_intatr(intno, intatr);

    /*
     *  ݗv}XN(Kvȏꍇ)
     *  ɊݗDxZbg
     */
    if ((intatr & TA_ENAINT) != 0U) {
        (void) x_enable_int(intno);
    }    
}

/*
 * CPUOnh̏
 * @}NɂAasp/kernel/exception.hŃvg^Cv錾
 * @Ă邽߁A֐ƂĒ`Ȃ΂ȂȂB
 */
void
initialize_exception(void)
{
}

#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 *  o^ĂȂOƌĂяo
 */
void
default_exc_handler(void *p_excinf)
{
    uint32_t *sp    = (uint32_t*)p_excinf;
    uint32_t vector = *(sp + P_EXCINF_OFFSET_VECTOR);
    uint32_t pc     = *(sp + P_EXCINF_OFFSET_PC);
    uint32_t sr     = *(sp + P_EXCINF_OFFSET_SR);
    uint32_t pr     = *(sp + P_EXCINF_OFFSET_PR);
    uint32_t reg, i;
    
    switch(vector) {
		case GENERAL_ILLEGAL_INSTRUCTION_VECTOR:
    		syslog(LOG_EMERG, "General illegal instruction exception occurs.");
    		break;
		case RAM_ERROR_VECTOR:
    		syslog(LOG_EMERG, "RAM error exception occurs.");
    		break;
		case SLOT_ILLEGAL_INSTRUCTION__VECTOR:
    		syslog(LOG_EMERG, "Slot illegal instruction exception occurs.");
    		break;
		case CPU_ADDRESS_ERROR_VECTOR:
    		syslog(LOG_EMERG, "CPU address error exception occurs.");
    		break;
		case DMA_ADDRESS_ERROR_VECTOR:
    		syslog(LOG_EMERG, "DMA address error exception occurs.");
    		break;

#ifdef FPU_VECTOR
		case FPU_VECTOR:
    		syslog(LOG_EMERG, "FPU exception occurs.");
    		break;
#endif /*  FPU_VECTOR  */

#ifdef SH2A
		case BANK_OVER_FLOW_VECTOR:
    		syslog(LOG_EMERG, "Bank over flow exception occurs.");
    		break;
		case BANK_UNDER_FLOW_VECTOR:
    		syslog(LOG_EMERG, "Bank under flow exception occurs.");
    		break;
#endif /*  SH2A  */

		default:
   			syslog(LOG_EMERG, "Unregistered Expevt error occurs.");
   			break;
   	}

    syslog(LOG_EMERG, "VectorNo = %d PC = 0x%08x SR = 0x%08x PR=0x%08x",
           vector, pc, sr, pr);
	for(i = 0; i < 8; ++i) {
		reg = *(sp + P_EXCINF_OFFSET_R0 + i);
    	syslog(LOG_EMERG, " r%d=0x%08x", i, reg);
    }
    target_exit();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 *  o^݂̊ꍇɌĂяo
 */
void
default_int_handler(void *p_excinf)
{
    INTNO intno = (INTNO)(*((uint32_t*)p_excinf));
    
    syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
    syslog(LOG_EMERG, "INTNO = %d",intno);
    target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
