/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_config.h 697 2007-12-25 04:43:57Z honda $
 */

/*
 *		vZbTˑW[iSH12Apj
 *
 *  ̃CN[ht@ĆCtarget_config.hi܂́CCN
 *  [ht@Cĵ݂CN[hD̃t@C
 *  ڃCN[hĂ͂ȂȂD
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ˑ̃CC֐
 */
/*  queue.h  */
#pragma inline (queue_initialize, queue_insert_prev, queue_delete)
#pragma inline (queue_delete_next, queue_empty)
/*  cyclic.c  */
#pragma inline (tmevtb_enqueue_cyc)
/*  mailbox.c  */
#pragma inline (enqueue_msg_pri)
/*  task.c  */
#pragma inline (bitmap_search, primap_empty, primap_search, primap_set, primap_clear)
/*  time_event.h  */
#pragma inline (tmevtb_enqueue, tmevtb_enqueue_evttim, tmevtb_dequeue)
/*  time_event.c  */
#pragma inline (tmevtb_delete_top)
/*  wait.c  */
#pragma inline (make_non_wait, wobj_queue_insert)
/*  wait.h  */
#pragma inline (queue_insert_tpri, make_wait, wait_dequeue_wobj, wait_dequeue_tmevtb)
#pragma inline (wait_tskid, wobj_change_priority)


/*
 *  ˑ̃CC֐
 */
#pragma inline (sense_context, x_lock_cpu, x_unlock_cpu, x_sense_lock)
#pragma inline (x_set_ipm, x_get_ipm, x_disable_int, x_enable_int)
#pragma inline (i_begin_int, exc_sense_context, exc_get_iipm)
#pragma inline (exc_sense_intmask, exc_sense_unlock, call_atexit)


/*
 *  vZbT̓ꖽ߂̃CC֐`
 */
#include "prc_insn.h"

/*
 *  o^̊ݗp̃Gg
 */
extern void default_int_handler_entry(void);

/*
 *  ^XNReLXgp̃X^bNl
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

/*
 *  ^XNReLXgubN̒`
 */
typedef struct task_context_block {
	void	*sp;		/* X^bN|C^ */
	FP		pc;			/* vOJE^ */
} CTXB;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ݗDx}XN색Cu
 *  
 *  SH12Ał́CXe[^XWX^iSRj4`7rbgڂ4rbgɊݗDx
 *  }XNin[hEFÅݗDx}XNCIPMjuĂDIPM
 *  Ă߂ɁCݗDx̊O\i-1A̒ljg
 *  Ƃ\ł邪C]vȍErbgVtgƕ]KvɂȂD
 *  邽߂ɁCIPMۑꍇɂ́CSR4`7rbg߂ol
 *  gƂɂD̒lݗDx}XN̓\ƌĂсCIIPMƏ
 *  ƂɂD
 */

/*
 *  ݗDx}XN̊O\Ɠ\̕ϊ
 *
 *  AZũ\[Xt@CCN[hꍇ̂߂ɁCCASTgp
 */
#define EXT_IPM(iipm)    (-CAST(PRI,(iipm) >> 4))       /* \O\ */
#define INT_IPM(ipm)     (CAST(uint32_t, -(ipm)) << 4)  /* O\\ */

#ifndef TOPPERS_MACRO_ONLY

/*  SRWX^Irbg  */
#define SH_SR_I_BIT		0x000000F0U

/*
 *  IPMin[hEFÅݗDx}XNC\ǰݒl̓Ǐo
 *  @@nishcj̑g݊֐get_imask()́Arbg0n܂悤
 *  @@VtgʂԂ̂ŁAcurrent_sr()gp悢B
 */
#define current_iipm()	(current_sr() & SH_SR_I_BIT)

/*
 *  IPMin[hEFÅݗDx}XNC\ǰݒl̐ݒ
 */
#define set_iipm(iipm)	set_sr((current_sr() & ~SH_SR_I_BIT) | (iipm))

/*
 *  TOPPERSWݏf̎
 *
 *  SH12A̓Xe[^XWX^(SR)ɊݗDx}XN(IPM)ĂD
 *  CPUbNtOɑ@\ȂD̂߁C[ICPUbNt
 *  OD
 *
 *  ܂CCPUbNԂǗ߂̕ϐ(lock_flag)pӂD
 *
 *  CPUbNtONAĂԂ́CIPMf̊ݗDx
 *  }XN̒lɐݒ肷D̊Ԃ́Cf̊ݗDx}XŃC
 *  IPMpD
 * 
 *  ɑ΂CPUbNtOZbgꂢԂ́CIPMCJ[l
 *  Ôׂ̂Ă̊ݗv}XNl(TIPM_LOCK)ƁCf
 *  ̊ݗDx}XNƂ̍ɐݒ肷D̊Ԃ̃f̊
 *  ݗDx}XŃĈ߂̕ϐ(saved_iipm, \ŕێ)p
 *  ӂĕێD
 *
 *  SH12Ał́C݂̓Ŋ݂󂯕t\D̂߁C
 *  ݂̏oł́C߂悪^XN肷KvD̂߂ɂ́C
 *  X^bNɐς܂ꂽSRIPM^XNŝIPM`FbNKv
 *  D^XNsIPM̐ݒl saved_iipm pĎ擾邽߁C
 *  ^XNReLXgł́CCPUbNԈȊOł́Csaved_iipm ͏
 *  IPMƓlɂȂ悤ɂD
 */

/*
 *  ReLXgQƂ̂߂̕ϐ
 */
extern uint32_t excnest_count; /* Oi/CPUOj̃lXg񐔂̃JEg */

/*
 *  ReLXg̎Q
 *
 *  SH12Ał́CReLXg̔ɁC/CPUÕlXg񐔂Ǘ
 * 
 */
Inline bool_t
sense_context(void)
{
    return(excnest_count > 0U);
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUbNԂł̊ݗDx}XN
 *
 *  TIPM_LOCḰCCPUbNԂł̊ݗDx}XNCȂ킿CJ[l
 *  ǗÔׂ̂Ă݂̊}XNlɒ`D
 */
#define TIPM_LOCK    TMIN_INTPRI

/*
 *  CPUbNԂł̊ݗDx}XN̓\
 */
#define IIPM_LOCK    INT_IPM(TIPM_LOCK)

/*
 *  TIPM_ENAALLiݗDx}XNSj̓\
 */
#define IIPM_ENAALL  INT_IPM(TIPM_ENAALL)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPUbNtÔ߂̕ϐ
 * 
 *  ̕ϐ́CCPUbNԂ̎̂ݏĂ悢ƂD
 *  CC֐ŁCANZX̏ωȂ悤Cvolatile wD 
 */
extern volatile bool_t     lock_flag;   /* CPUbNtO̒lێϐ */
extern volatile uint32_t saved_iipm;  /* ݗDx}XNϐ */

/*
 *  CPUbNԂւ̈ڍs
 *
 *  IPMin[hEFÅݗDx}XNjCsaved_iipmɕۑCJ[
 *  lǗÔׂ̂Ă݂̊}XNliTIPM_LOCKjɐ
 *  肷D܂Clock_flagtrueɂD
 *
 *  IPMCŏTIPM_LOCKƓ荂ꍇɂ́C
 *  saved_iipmɕۑ݂̂ŁCTIPM_LOCKɂ͐ݒ肵ȂD́Cf
 *  ̊ݗDx}XNCTIPM_LOCKƓ荂xɐݒ
 *  ĂԂɂD
 *
 *  ̊֐́CCPUbNԁilock_flagtruȅԁjŌĂ΂邱Ƃ
 *  Ȃ̂Ƒz肵ĂD
 */
Inline void
x_lock_cpu(void)
{
    uint32_t iipm;

    /*
     *  current_iipm()̕Ԃl𒼐saved_iipmɕۑCꎞϐiipm
     *  pĂ̂́Ccurrent_iipm()Ă񂾒Ɋ݂C
     *  Nꂽݏsaved_iipmύX\邽߂
     *  D
     */
    iipm = current_iipm();
    if (IIPM_LOCK > iipm) {
        set_iipm(IIPM_LOCK);
    }
    saved_iipm = iipm;    
    lock_flag = true;
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUbNԂ̉
 *
 *  lock_flagfalseɂCIPMin[hEFÅݗDx}XNjC
 *  saved_iipmɕۑlɖ߂D
 *
 *  ̊֐́CCPUbNԁilock_flagtruȅԁjł̂݌Ă΂
 *  ̂Ƒz肵ĂD
 */
Inline void
x_unlock_cpu(void)
{
    lock_flag = false;
    set_iipm(saved_iipm);
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  CPUbNԂ̎Q
 */
Inline bool_t
x_sense_lock(void)
{
    return(lock_flag);
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()

/*
 *  chg_ipmŗLȊݗDx͈̔͂̔
 *
 *  TMIN_INTPRI̒lɂ炸Cchg_ipmł́C-15`TIPM_ENAALLi0j͈̔
 *  ɐݒł邱ƂƂi^[Qbg`̊gjD
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-15 <= (intpri)) && ((intpri) <= TIPM_ENAALL))

/*
 * if́jݗDx}XN̐ݒ
 *
 *  CPUbNtONAĂ鎞́Cn[hEFÅݗDx}
 *  XNݒ肷D
 *  
 *  CPUbNtOZbgĂ鎞́Cn[hEFÅݗDx}
 *  XNCݒ肵悤Ƃif́jݗDx}XNTIPM_LOCK
 *  ̍ɐݒ肷D
 *
 */
Inline void
x_set_ipm(PRI intpri)
{
    uint32_t   iipm = INT_IPM(intpri);

    
    if (!lock_flag) {
        set_iipm(iipm);
    }
    else {
        saved_iipm = iipm;
#if TIPM_LOCK == -15
        /*
         *  TIPM_LOCK-15̏ꍇɂ́C̎_Ńn[hEFÅݗD
         *  x}XNK15ɐݒ肳Ă邽߁Cݒ肵KvȂD
         */
#else /* TIPM_LOCK == -15 */
        if (!(iipm > IIPM_LOCK)) {
			iipm = IIPM_LOCK;
		}
        set_iipm(iipm);
#endif /* TIPM_LOCK == -15 */
    }
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * if́jݗDx}XN̎Q
 *
 *  CPUbNtONAĂ鎞̓n[hEFÅݗDx}
 *  XNCZbgĂ鎞saved_iipmQƂD
 */
Inline PRI
x_get_ipm(void)
{
    uint32_t iipm;

    if (!lock_flag) {
        iipm = current_iipm();
    }
    else {
        iipm = saved_iipm;
    }
    return(EXT_IPM(iipm));
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *  ōD揇ʃ^XNւ̃fBXpb`iprc_support.srcj
 *
 *  dispatch́C^XNReLXgĂяoꂽT[rXR[
 *  ĂяôׂŁC^XNReLXgECPUbNԁEfBXpb
 *  `ԁEif́jݗDx}XNSԂŌĂяo
 *  ΂ȂȂD
 */
extern void dispatch(void);

/*
 *  fBXpb`̓Jniprc_support.srcj
 *
 *  start_dispatch́CJ[lNɌĂяôׂŁCׂĂ̊
 *  ݂֎~ԁiS݃bNԂƓ̏ԁjŌĂяoȂ
 *  ȂȂD
 */
extern void start_dispatch(void);

/*
 *  ݂̃ReLXĝĂăfBXpb`iprc_support.srcj
 *
 *  exit_and_dispatch́Cext_tskĂяôׂŁC^XNReL
 *  XgECPUbNԁEfBXpb`ԁEif́jݗD
 *  x}XNSԂŌĂяoȂ΂ȂȂD
 */
extern void exit_and_dispatch(void);

/*
 *  J[l̏Ǐďoiprc_support.srcj
 *
 *  call_exit_kerneĺCJ[l̏IɌĂяôׂŁC^XN
 *  ReLXgɐ؂芷āCJ[l̏Iiexit_kerneljĂяo
 *  D
 */
extern void call_exit_kernel(void);

/*
 *  ^XNReLXg̏
 *
 *  ^XNx~ԂsłԂɈڍs鎞ɌĂ΂D̎_
 *  ŃX^bN̈gĂ͂ȂȂD
 *
 *  activate_contextCCC֐ł͂Ȃ}N`ƂĂ̂́C
 *  ̎_łTCB`ĂȂ߂łD
 */
extern void    start_r(void);

#define activate_context(p_tcb)                                         \
{                                                                       \
    (p_tcb)->tskctxb.sp = (void *)((char *)((p_tcb)->p_tinib->stk)      \
                                        + (p_tcb)->p_tinib->stksz);     \
    (p_tcb)->tskctxb.pc = (FP) start_r;                                 \
}

/*
 *  calltex͎gpȂ
 */
#define OMIT_CALLTEX

/*
 * ^[QbgˑɊ܂܂W̗OǗ@\̏pȂ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPUOnh̏
 * @}NɂAasp/kernel/exception.hŃvg^Cv錾
 * @Ă邽߁A֐ƂĒ`Ȃ΂ȂȂB
 */
extern void initialize_exception(void);

/*
 *  SH12Å݃A[LeN`Ɗݏf̎
 * 
 *  SH12Ǻ݂CӃW[݁CIRQ݂ɕނłC
 *  ꈵقȂD̂߁C݃nhԍCǂ݂̊ɕ
 *  邽߂̃}NpӂD
 */
     
/*
 *  ݗDx
 *
 *  e݂̊ݗDx͊ݗD揇ݒ背WX^(IPRXX)ɂĐ
 *  肷DӃW[̏ꍇCӃW[ɐݒ\łD
 *  ႦSCIF́CERI2, RXI2, BRI2, TXI2Ƃ4̊ݗvCT
 *  |[g邪CSĂ̊ݗvCɑ΂ē̗Dxݒ
 *  ȂD̂߁CeݗvCɂǂ̊ݗD揇ݒ背WX
 *  ^ݒ肷邩`e[upӂD܂Cݔԍ͘A
 *  ĂȂ߁CT|[gĂȂԍɂ́Cnumber-1ݒ肷D
 */

/*
 *  eݔԍ̐ݒ肷IPȐǗ̂߂̍\  
 *  
 *  @ooffset8rbgΏ\AL̗R32rbgɂĂB
 *  @@E̍\̂zɂƌԂł邾ŁA̐ߖɂȂȂB
 *  @@ESHł32rbgf[^łȂƖʂȖ߂B
 */
typedef struct {
    /* ݗD揇ݒ背WX^̃AhX */
		    /*  @ToDo {̓|C^ɂׂ  */
    uint32_t	address; 
    /* ItZbg */
    uint32_t	offset;
} IPR_INFO;

/*
 *  eݔԍIPȐǗe[u
 */
extern const IPR_INFO ipr_info_tbl[TNUM_INH];
    
/*
 *  ݔԍE݃nhԍ
 *
 *  ݃nhԍ(inhno)Ɗݔԍ(intno)́CxN^ԍpD
 *
 *  xN^ԍ64n܂邽߁Ĉ܂܂̒lDxǗ̃e[u
 *  CfbNXɗpƁCʂȗ̈悪D̂߁CJ[l
 *  ł́C-64lpD
 *
 *  \̖ÓCiintno,iinhnoƂD
 */

/*
 * ݃nhԍ̓EO\ݕϊ
 */
/* \O\ */
#define EXT_INHNO(iintno) (CAST(uint32_t, (iinhno) + TMIN_INHNO)) 
/* O\\ */
#define INT_INHNO(intno)  (CAST(uint32_t, (inhno) - TMIN_INHNO))  

/*
 * ݔԍ̓EO\ݕϊ
 */
/* \O\ */
#define EXT_INTNO(iintno)   (CAST(uint32_t, (iintno) + TMIN_INTNO)) 
/* O\\ */
#define INT_INTNO(intno)    (CAST(uint32_t, (intno) - TMIN_INTNO))  


/*
 *  ݔԍ͈̔͂̔
 * 
 *  TMIN_INTNOTMAX_INTNO͈̔͂łĂLȔԍłȂꍇ邽
 *  ߁Cipr_info_tbl[]ŗLȔԍ`FbN
 */

/*
 *  ݔԍɑΉIPRWX^̃AhXLH
 * 
 *  ݔԍ\ɕϊĂAe[uB
 */
#define VALID_INTNO_IPR_ADDR(intno)	(ipr_info_tbl[INT_INTNO(intno)].address != 0U)

#define VALID_INTNO(intno) \
        ((TMIN_INTNO <= (intno)) && ((intno) <= TMAX_INTNO) && VALID_INTNO_IPR_ADDR(intno))
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)

/*
 *  CPUOnhԍ
 *
 *  CPUOnhԍƂẮCxN^ԍpD
 *  T|[gCPUOnh̓vZbŤ^ԖɈقȂ̂ŁCv
 *  ZbŤ^Ԗ̒`t@Cɒ`D
 *
 */
#define VALID_EXCNO_DEFEXC(excno) \
        ((TMIN_EXCNO <= (excno)) && ((excno) <= TMAX_EXCNO))

/*
 *  ݃nh̐ݒ
 *
 *  xNgԍinhno̊݃nh̋NԒnint_entryɐݒ肷D
 *  sh12ał͉Ȃ̂ŁACC֐ł͂Ȃ̃}NɂĂB
 */
#define x_define_inh(inhno, int_entry)

/*
 *  ݃nh̏o̐}N
 *
 */
#define _INT_ENTRY(inhno, inthdr)    _kernel_##inthdr##_##inhno
#define INT_ENTRY(inhno, inthdr)     _INT_ENTRY(inhno, inthdr)

#define _INTHDR_ENTRY(inhno, inthdr) extern void _kernel_##inthdr##_##inhno(void);
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)  _INTHDR_ENTRY(inhno, inthdr) 

/*
 *  ݗv֎~tO
 *
 *  SH12AIRC͊ݗv֎~tOȂD݂֎~ꍇ́C
 *  ݗD揇ݒ背WX^(IPRXX)0ɐݒ肷KvDݗD
 *  揇ݒ背WX^0ɂ邱ƂŊݗv֎~tOƂ
 *  ԁCݗDxLĂ̈悪KvƂȂDRtBM[^
 *  ł̃e[upӂD܂CMSBɂ́C݂̊DEF_INHŒ`
 *  ĂȂ"1"ZbgD
 *  
 *  iimp𖼑OɎgĂ邪A4rbgVtgĂȂ߁A
 *  ɂ͓\Ƃ͈قȂB
 */
extern const uint8_t int_iipm_tbl[TNUM_INT];

/*
 *  ݗv֎~tÕZbg
 *
 *  ݗD揇ݒ背WX^(IPRA`G)0ɐݒ肷D
 *
 *  ݑݒ肳ĂȂݗvCɑ΂Ċݗv֎~
 *  tONA悤Ƃꍇɂ́CfalseԂD
 */
Inline bool_t
x_disable_int(INTNO intno)
{
    uint32_t iintno  = INT_INTNO(intno);
    uint32_t address = ipr_info_tbl[iintno].address;
    uint32_t offset  = ipr_info_tbl[iintno].offset;
    uint32_t iipm    = int_iipm_tbl[iintno];

	/*
	 *  ݑݒ肳ĂȂꍇ
	 */
	if ((iipm & 0x80U) != 0) {
		return(false);
	}
    
    /* 
     *  ݔԍɑΉIPR̒l0ɂD
     */
    set_irc_ipr(address, offset, 0x00);

    return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ݗv֎~tỎ
 *
 *  ݗD揇ݒ背WX^(IPRA`G)̒lɖ߂D
 *
 *  ݑݒ肳ĂȂݗvCɑ΂Ċݗv֎~
 *  tONA悤Ƃꍇɂ́CfalseԂD
 */
Inline bool_t
x_enable_int(INTNO intno)
{
    uint32_t iintno  = INT_INTNO(intno);
    uint32_t address = ipr_info_tbl[iintno].address;
    uint32_t offset  = ipr_info_tbl[iintno].offset;
    uint32_t iipm    = int_iipm_tbl[iintno];

	/*
	 *  ݑݒ肳ĂȂꍇ
	 */
	if ((iipm & 0x80U) != 0) {
		return(false);
	}

    /* 
     *  ݔԍɑΉIPR̒lZbg
     */
    set_irc_ipr(address, offset, (iipm & 0x0FU));
    
    return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *  ݗvC̑̐ݒ
 *
 *  SH12Ał́CJ[lň銄ݗDx16iKł邽߁Cintpri
 *  Ƃė^邱Ƃłl-15`-1WłD
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ݃nhŕKvIRC
 *
 *  IRQ݂łGbWgK̏ꍇ͊ݗvNAD
 *  GbWgKf̂ʓ|Ȃ̂ŁCɃNAD
 */
Inline void
i_begin_int(INTNO intno)
{
    uint32_t dummy;
    if (INTNO_IRQ(intno)) {
        i_lock_cpu();
        /* ǂݍ */
        dummy = sil_reh_mem((void *)IRQRR);
        sil_wrh_mem((void *)IRQRR, dummy & ~(0x01U << INTNO_TO_IRQNO(intno)));
        i_unlock_cpu();
    }
}

/*
 *  ݃nh̏oŕKvIRC
 *    sh12ał͉Ȃ̂ŁACC֐ł͂Ȃ̃}NɂĂB
 */
#define i_end_int(intno)

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUOnh֌W
 */

/*
 *  Onh p_excinf eo߂̃}N
 */
#define P_EXCINF_OFFSET_VECTOR UINT_C( 0)
#define P_EXCINF_OFFSET_PR     UINT_C( 1)
#define P_EXCINF_OFFSET_SR     UINT_C(13)
#define P_EXCINF_OFFSET_PC     UINT_C(12)

#define P_EXCINF_OFFSET_R0     UINT_C( 4)

#ifndef TOPPERS_MACRO_ONLY
/*
 *  CPUOnh̐ݒ
 */
#define x_define_exc(excno, exc_entry)

/*
 *  CPUOnh̓̐}N
 */
#define EXC_ENTRY2(excno, exchdr)    _kernel_##exchdr##_##excno
#define EXC_ENTRY(excno, exchdr)     EXC_ENTRY2(excno, exchdr)
#define EXCHDR_ENTRY2(excno, exchdr) extern void _kernel_##exchdr##_##excno(void *sp);
#define EXCHDR_ENTRY(excno, excno_num, exchdr)  EXCHDR_ENTRY2(excno, exchdr)

/*
 *  CPUO̔̃ReLXg̎Q
 *
 *  CPUO̔̃ReLXgC^XNReLXg̎falseC
 *  łȂtrueԂD
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
    return(excnest_count > 1U);
}

/*
 *  CPUO̔IPMin[hEFÅݗDx}XNC\
 *  j̎Q
 */
Inline uint32_t
exc_get_iipm(void *p_excinf)
{
	uint32_t iipm;
	uint32_t *sp = (uint32_t *) p_excinf;
	sp += P_EXCINF_OFFSET_SR;
    iipm = (*sp) & SH_SR_I_BIT;
    return(iipm);
}

/*
 *  CPUO̔̃ReLXgƊ݂̃}XNԂ̎Q
 *
 *  CPUO̔̃VXeԂCJ[lsłȂC^XNR
 *  eLXgłCS݃bNԂłȂCCPUbNԂłȂCi
 *  f́jݗDx}XNSԂł鎞trueCłȂ
 *  falseԂiCPUOJ[lǗO̊ݏŔꍇ
 *  ɂfalseԂjD
 *
 *  SHł́CCPUO̔IPMin[hEFÅݗDx}XNj
 *  ׂĂ݂̊Ԃł邱Ƃ`FbN邱ƂŁCJ[
 *  lsłȂƁCS݃bNԂłȂƁCCPUbNԂł
 *  ƁCif́jݗDx}XNSԂł邱Ƃ4
 *  `FbN邱ƂłiCPUOlock_flagQ
 *  ƂKv͂ȂjD
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
    return(!exc_sense_context(p_excinf)
                    && (exc_get_iipm(p_excinf) == IIPM_ENAALL));
}

/*
 *  CPUO̔̃ReLXgƊ݁^CPUbNԂ̎Q
 *
 *  CPUO̔̃VXeԂCJ[lsłȂC^XNR
 *  eLXgłCS݃bNԂłȂCCPUbNԂłȂ
 *  trueCłȂfalseԂiCPUOJ[lǗO̊ݏ
 *  ŔꍇɂfalseԂjD
 *
 *  SH12ł́CCPUO̔IPMin[hEFÅݗDx}
 *  XNjTIPM_LOCKႢƂ`FbN邱ƂŁCJ[ls
 *  ȂƁCS݃bNԂłȂƁCCPUbNԂłȂƂ3
 *  ̏`FbNĂiCPUOlock_flag͎QƂ
 *  ȂjDɂCif́jݗDx}XNTIPM_LOCK
 *  ɐݒ肵ă^XNsĂ鎞ɂfalseԂĂ܂Cf
 *  mɂ邽߂̃I[owbh傫ƂCe邱ƂɂD
 */
Inline bool_t
exc_sense_unlock(void *p_excinf)
{
    return(!exc_sense_context(p_excinf)
                    && (exc_get_iipm(p_excinf) < IIPM_LOCK));
}

/*
 * TrapaȊO̗Oœo^ĂȂOƌĂяo
 */
extern void default_exc_handler(void *p_excinf);

/*
 * o^݂̊ꍇɌĂяo
 */
extern void default_int_handler(void *p_excinf);

/*
 *  vZbTˑ̏
 */
extern void prc_initialize(void);

/*
 *  vZbTˑ̏I
 */
extern void prc_terminate(void);

/*
 *  atexit̏ƃfXgN^̎s
 */
Inline void
call_atexit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookւ̃|C^CUvolatileŵfpɑ
     *  Ăĝ́C0Ƃ̔rœKō폜Ȃ悤ɂ邽
     *  ߂łD
     */
    if (fp != 0) {
        (*fp)();
    }
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
