/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_timer.c 473 2007-08-10 06:59:14Z honda $
 */

/*
 *  ^C}hCoiSH12Apj
 * 
 *  CMT0gp 
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"
 
/*
 *  ^C}̋N
 */
void
target_timer_initialize(intptr_t exinf)
{
    CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

    /*
     *  ^C}ݒ肵C^C}̓JnD
     */
    /* CMT0~ */
    sil_wrh_mem((void*)CMSTR,
                (sil_reh_mem((void*)CMSTR) & ~CMSTR_STR0));

    /* ^C}l̃`FbN */
    assert(cyc <= MAX_CLOCK);             

    /* ݒ(PCLOCK/8)A荞݋ */
    sil_wrh_mem((void*)CMCSR_0, (CMCSR_CKS  | CMCSR_CMIE));

    /*constantWX^Zbg */
    sil_wrh_mem((void*)CMCOR_0, cyc); 

    /* CMT0X^[g */
    sil_wrh_mem((void*)CMSTR,
                (sil_reh_mem((void*)CMSTR) | CMSTR_STR0));      

    /* 荞ݗvNA */
    sil_wrh_mem((void*)CMCSR_0,
                (sil_reh_mem((void*)CMCSR_0) & ~CMCSR_CMF));
}

/*
 *  ^C}̒~
 */
void
target_timer_terminate(intptr_t exinf)
{
    /* ^C}~ */
    sil_wrh_mem((void*)CMSTR,
                (sil_reh_mem((void*)CMSTR) & ~CMSTR_STR0));
    
    /* 荞ݗvNA */
    sil_wrh_mem((void*)CMCSR_0,
                (sil_reh_mem((void*)CMCSR_0) & ~CMCSR_CMF));

}

/*
 *  ^C}݃nh
 */
void
target_timer_handler(void)
{
    /* 荞ݗvNA */
    sil_wrh_mem((void*)CMCSR_0,
                (sil_reh_mem((void*)CMCSR_0) & ~CMCSR_CMF));
    
    i_begin_int(INTNO_TIMER);
    signal_time();                    /* ^CeBbN̋ */
    i_end_int(INTNO_TIMER);
}
