/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: sh2a_config.h 697 2007-12-25 04:43:57Z honda $
 */

/*
 *		vZbTˑW[iSH2Apj
 *
 *  ̃CN[ht@ĆCsh7xxx_config.hi܂́CCN
 *  [ht@Cĵ݂CN[hD̃t@C
 *  ڃCN[hĂ͂ȂȂD
 */

#ifndef TOPPERS_SH2A_CONFIG_H
#define TOPPERS_SH2A_CONFIG_H

#pragma inline (set_irc_ipr, x_config_intatr)

/*
 *  vZbT̎
 */
#define SH2A


/*
 *  IRQ݂ǂ𔻒肷邽߂̃}N
 */
#define INTNO_IRQ0 		64U
#define INTNO_IRQ_MAX	71U
#define INTNO_IRQ(intno) ((INTNO_IRQ0 <= (intno)) && ((intno) <= INTNO_IRQ_MAX))
#define INTNO_TO_IRQNO(intno) (((intno) - INTNO_IRQ0))


#ifndef TOPPERS_MACRO_ONLY
/*
 * ݗDxWX^̐ݒ
 */
Inline void
set_irc_ipr(uint32_t address, uint32_t offset, uint32_t val)
{
    uint32_t ipr_val;

    ipr_val = sil_reh_mem((void *) address);
    ipr_val &= ~(0x0FU << offset);
    ipr_val |= (uint32_t)val << offset;
    sil_wrh_mem((void *) address, ipr_val);
}

/*
 *  ݂̑ݒ
 */
Inline void
x_config_intatr(INTNO intno, ATR intatr)
{
    /*
     *  IRQ̂݃T|[g
     */
    if(INTNO_IRQ(intno) != 0U){
        uint32_t icr1_val = sil_reh_mem((void*)ICR1);
        uint32_t offset   = INTNO_TO_IRQNO(intno) * 2U;

        icr1_val &=  ~(0x03U << offset);
        
        if((intatr & TA_POSEDGE) != 0U) {
            /*
             *  |WeBuGbW
             */
            icr1_val |= IRQ_POSEDGE << offset;            
        }

        if((intatr & TA_NEGEDGE) != 0U) {
            /*
             *  lKeBuGbW
             */
            icr1_val |= IRQ_NEGEDGE << offset;                        
        }
        
        sil_wrh_mem((void*)ICR1, icr1_val);
    }
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  vZbTˑW[iSH12Apj
 */
#include "sh12a_hew\prc_config.h"

#endif /* TOPPERS_SH2A_CONFIG_H */
